#==============================================================================
# 		fichier de D'INSTRUCTIONS de référence
#Julien Brajard
#==============================================================================
#script faisant l'assimilation de référence
#paramètres à régler : TA=50 (48 pdt effectifs)
#NX=32,NY=22,NZ=31
#paramères de contrôle : sshn_c, ta_c, sa_c, ua_c, va_c
#obs (3D a t=48 Yt=50) : sshb, tb, sb,ub,vb
#ATTENTION : la minimisation ne se passe pas bien encore

##INITIALISATION
xistate_init 1 ../data_in/file_rest/GYRE_00000424_restart.nc
true_target_in_tab ta_c


savestate sshn_c  1   ij   0    A       1       ../data_out/sshn_c_true.dat
savestate ta_c  1   ijk   0    A       1       ../data_out/ta_c_true.dat
savestate sa_c  1   ijk   0    A       1       ../data_out/sa_c_true.dat
savestate ua_c  1   ijk   0    A       1       ../data_out/ua_c_true.dat
savestate va_c  1   ijk   0    A       1       ../data_out/va_c_true.dat

print_time OFF
set_modeltime 0
FORWARD


##OBSERVATION
savestate sshb  1   ij   50    A       1       ../data_out/sshb_obs_48.dat   
savestate tb  1   ijk   50    A       1       ../data_out/tb_obs_48.dat   
savestate sb  1   ijk   50    A       1       ../data_out/sb_obs_48.dat   
savestate ub  1   ijk   50    A       1       ../data_out/ub_obs_48.dat   
savestate vb  1   ijk   50    A       1       ../data_out/vb_obs_48.dat   

loadobs sshb  1   ij   50    A       1       ../data_out/sshb_obs_48.dat D   
loadobs tb  1   ijk   50    A       1       ../data_out/tb_obs_48.dat D   
loadobs sb  1   ijk   50    A       1       ../data_out/sb_obs_48.dat D   
loadobs ub  1   ijk   50    A       1       ../data_out/ub_obs_48.dat D   
loadobs vb  1   ijk   50    A       1       ../data_out/vb_obs_48.dat D   


#goto FINRUN

##INITIALISATION DE L'ASSIMILATION'
xistate_init 1 ../data_in/file_rest/GYRE_00000400_restart.nc
set_modeltime 0
print_time OFF
FORWARD
savestate sshn_c  1   ij   0    A       1       ../data_out/sshn_c_init.dat
savestate ta_c  1   ijk   0    A       1       ../data_out/ta_c_init.dat
savestate sa_c  1   ijk   0    A       1       ../data_out/sa_c_init.dat
savestate ua_c  1   ijk   0    A       1       ../data_out/ua_c_init.dat
savestate va_c  1   ijk   0    A       1       ../data_out/va_c_init.dat

##TEST DE LA FONCTION OBJECTIVE
goto FINTEST
testof 1.e+00 0.5e-01 2. 10 1
goto FINRUN
FINTEST
##DEBUT DE L'ASSIMILATION'

set_modeltime 0
!echo "RUN OPTIMIZATION WITH M1QN3 ......."
setm_impres  5
setm_io      6
setm_mode    1
set_nbiter   100
setm_nsim    100
setm_dxmin   1.0e-4
setm_epsg    1.0e-10
setm_ddf1    100
runm
##SAUVEGARDE
savestate sshn_c  1   ij   0    A       1       ../data_out/sshn_c_fin.dat
savestate ta_c  1   ijk   0    A       1       ../data_out/ta_c_fin.dat
savestate sa_c  1   ijk   0    A       1       ../data_out/sa_c_fin.dat
savestate ua_c  1   ijk   0    A       1       ../data_out/ua_c_fin.dat
savestate va_c  1   ijk   0    A       1       ../data_out/va_c_fin.dat

goto FINRUN

## analytiquement (2) 
xistate_init 1 ../data_in/file_rest/GYRE_00000424_restart.nc
#xistate_init 1 ../data_in/file_rest/GYRE_00000400_restart.nc




true_target_in_tab ta_c
savestate ta_c  1   ijk   0    A       1       ../data_out/ta_c_true.dat
print_time OFF
set_modeltime 0
FORWARD
savestate tb  1   ijk   0    A       3       ../data_out/tb_forw_init_424.dat   
GOTO FINRUN

#load_shape_func ta_c ../data_in/shfs/tb400-450/shfs15_N00_tb.dat
#load_mean 1 ta_c ../data_in/shfs/tb400-450/mean_N00_tb.dat
#load_stdev_pca ta_c ../data_in/shfs/tb400-450/stdevEOF_N00_tb.dat

#loadstate ta_c 1 ijk 0 a 1 ../data_in/start_in_tb/ta_start400.dat D
#loadstate ta_c  1   ijk 0    A       1   ../data_out/tb_st10.dat D   
#loadstate ta_c 1 ijk 0 a 1    ../data_out/ta_c_yao.dat D

#load_mean 0 ta_c | creating the observations 

#setstate pca_ta 0
GOTO NOF 
## Faire une simulation direct 
print_time OFF
set_modeltime 0
FORWARD
#savestate mod_name       ns  ijk   pdt  coding  format  file_name

#####savestate tb  1   ijk   0    A       3       ../data_out/tb_50.dat   
#savestate tb  1   ijk   23    A       1       ../data_out/tb_obs20_2.dat   
#savestate sshb  1   ij   23    A       1       ../data_out/sshb_obs20_0_1.dat   

savestate tb  1   ijk   23    A       1       ../data_out/tb_obs_std_424.dat   
savestate sshb  1   ij   23    A       1       ../data_out/sshb_obs_std_424.dat   

#savestate tb  1   ijk   10    A       1       ../data_out/tb_st10.dat   
#savestate tb  1   ijk   3    A       3       ../data_out/tb_sbd100.dat   
#savestate sb  1   ijk   3    A       3       ../data_out/sb_sbd100.dat   
#savestate ub  1   ijk   3    A       3       ../data_out/ub_sbd100.dat   
#savestate vb  1   ijk   3    A       3       ../data_out/vb_sbd100.dat   
#savestate sshb  1   ij   3    A       3       ../data_out/sshb_sbd100.dat   
###savestate ta  1   ijk   3    A       1       ../data_in/start_in_tb/ta_start400.dat   
                                                  | sauvegarder la
						  | sortie du module tb
						  | au pas du temps 100
#savestate sshb  1  ij   102    A       3       ../data_out/sshb100.dat
                                                  | sauvegarder la
						  | sortie du module sshb
						  | au pas du temps 100

GOTO FINRUN
NOF
#loadobs tb  1   ijk   23    A       1       ../data_out/tb_obs20_2.dat D   
loadobs tb  1   ijk   23    A       1       ../data_out/tb_obs_std_16_12_1_424.dat D   
#loadobs sshb  1   ij   23    A       1       ../data_out/sshb_obs20.dat D   
#loadstate ta_c 1 ijk 0 a 1 ../data_in/start_in_tb/GYRE_sortie_mohamed_ptb_198.dat D
#exit
print_cost ON
GOTO 3


GOTO TESTAD          |TESTLT |TESTAD |va vers TESTAD

outoobs sshb 1 12
outoobs tb 1 12

true_target_in_tab ta_c

GOTO TESTEND | TESTEND |TESTOF
FINTESTDF
#TEST DE LA PROGRAMMATION DES DERIVEES
TESTDF
testdf 3  3  1  4    f 1.e-10  0.001  10
stop
FINTESTDF

GOTO TESTEND
GOTO TESTEND
#-----------------
# TEST DE LINEAIRE TANGENT
TESTLT
 testlt 1.e+00 0.5e-01 2. 15
stop
#-----------------
#TEST DE L'ADJOINT
TESTAD
testad 0.001
stop
testad 0.001 1.0e-6  1000   1.0e-16
stop
#------------------
#TEST DE LA FONCTION OBJECTIVE
TESTOF
print_cost OFF
loadstate ta_c 1 ijk 0 a 1 ../data_in/start_in_tb/GYRE_sortie_mohamed_ptb_200.dat D
testof 1.e+00 0.5e-01 2. 10 1
TESTEND

#---------------------------------------------------------------------
#----------------------> choice of the run  <-------------------------
#---------------------------------------------------------------------
#-------> 1. RUNYAO
#-------> 2. RUNM2QN1
#-------> 3. RUNM1QN3

#charger l'état initial 
loadstate ta_c 1 ijk 0 a 1 ../data_in/start_in_tb/GYRE_sortie_mohamed_ptb_200.dat D

GOTO 3
#---------------------------------------------------------------------
1
!echo "RUN OPTIMIZATION WITH YRUN ......."
set_nbiter 20
setepsi ta_c 0.1
run
3
print_time OFF
set_modeltime 0
!echo "RUN OPTIMIZATION WITH M1QN3 ......."
setm_impres  5
setm_io      6
setm_mode    1
set_nbiter   100
setm_nsim    100
setm_dxmin   1.0e-4
setm_epsg    1.0e-10
setm_ddf1    1
runm

savestate ta_c  1   ijk   0    A       1       ../data_out/ta_c_yao.dat
savestate tb  1   ijk   23    A       1       ../data_out/tb_ret_424.dat   

goto FINRUN


FINRUN

